#pragma semicolon 1

#include <sourcemod>
#include <tf2>
#include <tf2_stocks>
#include <vip_core>

bool
    hChat,
    hLog;
    
#define PLUGIN_VERSION "1.3.0"
#define VIP_SetClassCore                "SetClassCore"
 
public Plugin myinfo = {
    name = "[CORE] Set Class",
    author = "Tylerst",
    description = "Set the target(s) class",
    version = PLUGIN_VERSION,
};

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max) {
    new String:Game[32];
    GetGameFolderName(Game, sizeof(Game));
    if(!StrEqual(Game, "tf"))
    {
        Format(error, err_max, "Цей плагін працює тільки для Team Fortress 2");
        return APLRes_Failure;
    }
    return APLRes_Success;
}

public void OnPluginStart()
{   
    RegConsoleCmd("sm_setclass", Command_Setclass, "Приклад: sm_setclass \"мета\" \"клас\"");   
    
    if(VIP_IsVIPLoaded())
        VIP_OnVIPLoaded();
    
    ConVar  Convar;
    (Convar = CreateConVar("sm_admin_clan_tage", "1", "Включення/Вимиканняe(1/0) Відображення змін setclass в чаті", _, true, 0.0, true, 1.0)).AddChangeHook(ChangeCvar_Chat);
    ChangeCvar_Chat(Convar, NULL_STRING, NULL_STRING);
    (Convar = CreateConVar("sm_admin_clan_tage", "1", "Включення/Вимикання(1/0) Протоколювання змін класу в логи", _, true, 0.0, true, 1.0)).AddChangeHook(ChangeCvar_Log);
    ChangeCvar_Log(Convar, NULL_STRING, NULL_STRING);
    AutoExecConfig(true, "SetClass");
    
    LoadTranslations("common.phrases");
}

public void ChangeCvar_Chat(ConVar Convar, const char[] oldValue, const char[] newValue) { hChat = Convar.BoolValue; }
public void ChangeCvar_Log(ConVar Convar, const char[] oldValue, const char[] newValue) { hLog = Convar.BoolValue; }

public void VIP_OnVIPLoaded() {
    VIP_RegisterFeature(VIP_SetClassCore, BOOL, HIDE);
}

public Action Command_Setclass(int client, int args)
{
    if (VIP_IsClientVIP(client) && IsPlayerAlive(client) && VIP_IsClientFeatureUse(client, VIP_SetClassCore)) {
        if(args != 2) {
            ReplyToCommand(client, "[SM] Приклад: sm_setclass \"мета\" \"клас\"");
        }
        else {
            new String:setclasstarget[MAX_NAME_LENGTH], String:strclass[10], TFClassType:class, String:target_name[MAX_TARGET_LENGTH], target_list[MAXPLAYERS], target_count, bool:tn_is_ml, random = false;
            GetCmdArg(1, setclasstarget, sizeof(setclasstarget));
            GetCmdArg(2, strclass, sizeof(strclass));
            if(StrEqual(strclass, "scout", false)) {
                class = TFClass_Scout;
                Format(strclass, sizeof(strclass), "Скаут");   
            }
            else if(StrEqual(strclass, "soldier", false)) {
                class = TFClass_Soldier;
                Format(strclass, sizeof(strclass), "Солдат");   
            }
            else if(StrEqual(strclass, "pyro", false)) {
                class = TFClass_Pyro;
                Format(strclass, sizeof(strclass), "Палій");   
            }
            else if(StrEqual(strclass, "demoman", false)) {
                class = TFClass_DemoMan;
                Format(strclass, sizeof(strclass), "Підривник");   
            }
            else if(StrEqual(strclass, "heavy", false)) {
                class = TFClass_Heavy;
                Format(strclass, sizeof(strclass), "Кулеметник");   
            }
            else if(StrEqual(strclass, "engineer", false)) {
                class = TFClass_Engineer;
                Format(strclass, sizeof(strclass), "Iнженер");   
            }
            else if(StrEqual(strclass, "medic", false)) {
                class = TFClass_Medic;
                Format(strclass, sizeof(strclass), "Медик");   
            }
            else if(StrEqual(strclass, "sniper", false)) {
                class = TFClass_Sniper;
                Format(strclass, sizeof(strclass), "Снайпер");   
            }
            else if(StrEqual(strclass, "spy", false)) {
                class = TFClass_Spy;
                Format(strclass, sizeof(strclass), "Шпигун");   
            }
            else if(StrEqual(strclass, "random", false)) {
                random = true;
                Format(strclass, sizeof(strclass), "Рандом");   
            }
            else {
                ReplyToCommand(client, "[SM] Неприпустимий клас (\"%s\")", strclass);
                return Plugin_Handled;
            }
            if((target_count = ProcessTargetString(
                    setclasstarget,
                    client,
                    target_list,
                    MAXPLAYERS,
                    COMMAND_FILTER_CONNECTED,
                    target_name,
                    sizeof(target_name),
                    tn_is_ml)) <= 0) {
                ReplyToTargetError(client, target_count);
                return Plugin_Handled;
            }
            for(new i = 0; i < target_count; i++) {
                if(random) class = TFClassType:GetRandomInt(1, 9);
                if(IsValidEntity(target_list[i])) {
                    TF2_SetPlayerClass(target_list[i], class);
                    if(IsPlayerAlive(target_list[i])) {
                        SetEntityHealth(target_list[i], 25);
                        TF2_RegeneratePlayer(target_list[i]);
                        new weapon = GetPlayerWeaponSlot(target_list[i], TFWeaponSlot_Primary);
                        if(IsValidEntity(weapon)) {
                            SetEntPropEnt(target_list[i], Prop_Send, "m_hActiveWeapon", weapon);
                        }
                    }

                }
                if(hLog) {
                    LogAction(client, target_list[i], "\"%L\" set class of  \"%L\" to (class %s)", client, target_list[i], strclass);   
                }
            }
            if(hChat) {
                ShowActivity2(client, "[SM] ","SВстановити клас %s задля %s", target_name, strclass);
            }   
        }
    }
    return Plugin_Handled;   
}

public void OnPluginEnd() {
    if (CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
        VIP_UnregisterFeature(VIP_SetClassCore);
}